/**
 * The SynDEX metamodel is under CeCILL-B FREE SOFTWARE LICENSE AGREEMENT
 * 
 * $Id: SyndexItemProviderAdapterFactory.java,v 1.1 2008-11-18 10:44:00 cbrunett Exp $
 */
package fr.inria.aoste.syndex.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import fr.inria.aoste.syndex.util.SyndexAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers. The adapters generated by this
 * factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}. The adapters
 * also support Eclipse property sheets. Note that most of the adapters are shared among multiple instances. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class SyndexItemProviderAdapterFactory extends SyndexAdapterFactory implements ComposeableAdapterFactory,
		IChangeNotifier, IDisposable
{
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	protected ComposedAdapterFactory	parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	protected IChangeNotifier			changeNotifier	= new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected Collection<Object>		supportedTypes	= new ArrayList<Object>();

	/**
	 * This constructs an instance. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public SyndexItemProviderAdapterFactory()
	{
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Actuator} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ActuatorItemProvider	actuatorItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Actuator}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createActuatorAdapter()
	{
		if (actuatorItemProvider == null)
		{
			actuatorItemProvider = new ActuatorItemProvider(this);
		}

		return actuatorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Sensor} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected SensorItemProvider	sensorItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Sensor}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createSensorAdapter()
	{
		if (sensorItemProvider == null)
		{
			sensorItemProvider = new SensorItemProvider(this);
		}

		return sensorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Application} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ApplicationItemProvider	applicationItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Application}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createApplicationAdapter()
	{
		if (applicationItemProvider == null)
		{
			applicationItemProvider = new ApplicationItemProvider(this);
		}

		return applicationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Input} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected InputItemProvider	inputItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Input}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createInputAdapter()
	{
		if (inputItemProvider == null)
		{
			inputItemProvider = new InputItemProvider(this);
		}

		return inputItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Output} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected OutputItemProvider	outputItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Output}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createOutputAdapter()
	{
		if (outputItemProvider == null)
		{
			outputItemProvider = new OutputItemProvider(this);
		}

		return outputItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Function} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected FunctionItemProvider	functionItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Function}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createFunctionAdapter()
	{
		if (functionItemProvider == null)
		{
			functionItemProvider = new FunctionItemProvider(this);
		}

		return functionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Constant} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ConstantItemProvider	constantItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Constant}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createConstantAdapter()
	{
		if (constantItemProvider == null)
		{
			constantItemProvider = new ConstantItemProvider(this);
		}

		return constantItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Delay} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected DelayItemProvider	delayItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Delay}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createDelayAdapter()
	{
		if (delayItemProvider == null)
		{
			delayItemProvider = new DelayItemProvider(this);
		}

		return delayItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.DataConnection} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected DataConnectionItemProvider	dataConnectionItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.DataConnection}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createDataConnectionAdapter()
	{
		if (dataConnectionItemProvider == null)
		{
			dataConnectionItemProvider = new DataConnectionItemProvider(this);
		}

		return dataConnectionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ComponentInstance} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ComponentInstanceItemProvider	componentInstanceItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ComponentInstance}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createComponentInstanceAdapter()
	{
		if (componentInstanceItemProvider == null)
		{
			componentInstanceItemProvider = new ComponentInstanceItemProvider(this);
		}

		return componentInstanceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.INInstance} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected INInstanceItemProvider	inInstanceItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.INInstance}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createINInstanceAdapter()
	{
		if (inInstanceItemProvider == null)
		{
			inInstanceItemProvider = new INInstanceItemProvider(this);
		}

		return inInstanceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.OutInstance} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected OutInstanceItemProvider	outInstanceItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.OutInstance}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createOutInstanceAdapter()
	{
		if (outInstanceItemProvider == null)
		{
			outInstanceItemProvider = new OutInstanceItemProvider(this);
		}

		return outInstanceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.InternalDependencyIN} instances.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected InternalDependencyINItemProvider	internalDependencyINItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.InternalDependencyIN}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createInternalDependencyINAdapter()
	{
		if (internalDependencyINItemProvider == null)
		{
			internalDependencyINItemProvider = new InternalDependencyINItemProvider(this);
		}

		return internalDependencyINItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.InternalDependencyOUT} instances.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected InternalDependencyOUTItemProvider	internalDependencyOUTItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.InternalDependencyOUT}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createInternalDependencyOUTAdapter()
	{
		if (internalDependencyOUTItemProvider == null)
		{
			internalDependencyOUTItemProvider = new InternalDependencyOUTItemProvider(this);
		}

		return internalDependencyOUTItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ConnecteableElement} instances.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ConnecteableElementItemProvider	connecteableElementItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ConnecteableElement}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createConnecteableElementAdapter()
	{
		if (connecteableElementItemProvider == null)
		{
			connecteableElementItemProvider = new ConnecteableElementItemProvider(this);
		}

		return connecteableElementItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.InCondPort} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected InCondPortItemProvider	inCondPortItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.InCondPort}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createInCondPortAdapter()
	{
		if (inCondPortItemProvider == null)
		{
			inCondPortItemProvider = new InCondPortItemProvider(this);
		}

		return inCondPortItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Hardware} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected HardwareItemProvider	hardwareItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Hardware}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createHardwareAdapter()
	{
		if (hardwareItemProvider == null)
		{
			hardwareItemProvider = new HardwareItemProvider(this);
		}

		return hardwareItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Media} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected MediaItemProvider	mediaItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Media}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createMediaAdapter()
	{
		if (mediaItemProvider == null)
		{
			mediaItemProvider = new MediaItemProvider(this);
		}

		return mediaItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.FPGA} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected FPGAItemProvider	fpgaItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.FPGA}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createFPGAAdapter()
	{
		if (fpgaItemProvider == null)
		{
			fpgaItemProvider = new FPGAItemProvider(this);
		}

		return fpgaItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Asic} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected AsicItemProvider	asicItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Asic}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createAsicAdapter()
	{
		if (asicItemProvider == null)
		{
			asicItemProvider = new AsicItemProvider(this);
		}

		return asicItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.DSP} instances. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected DSPItemProvider	dspItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.DSP}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createDSPAdapter()
	{
		if (dspItemProvider == null)
		{
			dspItemProvider = new DSPItemProvider(this);
		}

		return dspItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.RAM} instances. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected RAMItemProvider	ramItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.RAM}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createRAMAdapter()
	{
		if (ramItemProvider == null)
		{
			ramItemProvider = new RAMItemProvider(this);
		}

		return ramItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.SAM} instances. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected SAMItemProvider	samItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.SAM}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createSAMAdapter()
	{
		if (samItemProvider == null)
		{
			samItemProvider = new SAMItemProvider(this);
		}

		return samItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.SAMPTP} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected SAMPTPItemProvider	samptpItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.SAMPTP}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createSAMPTPAdapter()
	{
		if (samptpItemProvider == null)
		{
			samptpItemProvider = new SAMPTPItemProvider(this);
		}

		return samptpItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ConnectionHW} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ConnectionHWItemProvider	connectionHWItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ConnectionHW}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createConnectionHWAdapter()
	{
		if (connectionHWItemProvider == null)
		{
			connectionHWItemProvider = new ConnectionHWItemProvider(this);
		}

		return connectionHWItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.AssociationSWtoHW} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected AssociationSWtoHWItemProvider	associationSWtoHWItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.AssociationSWtoHW}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createAssociationSWtoHWAdapter()
	{
		if (associationSWtoHWItemProvider == null)
		{
			associationSWtoHWItemProvider = new AssociationSWtoHWItemProvider(this);
		}

		return associationSWtoHWItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.AssociationComtoProc} instances.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected AssociationComtoProcItemProvider	associationComtoProcItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.AssociationComtoProc}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createAssociationComtoProcAdapter()
	{
		if (associationComtoProcItemProvider == null)
		{
			associationComtoProcItemProvider = new AssociationComtoProcItemProvider(this);
		}

		return associationComtoProcItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Duration} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected DurationItemProvider	durationItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Duration}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createDurationAdapter()
	{
		if (durationItemProvider == null)
		{
			durationItemProvider = new DurationItemProvider(this);
		}

		return durationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.EnumLitDuration} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EnumLitDurationItemProvider	enumLitDurationItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.EnumLitDuration}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createEnumLitDurationAdapter()
	{
		if (enumLitDurationItemProvider == null)
		{
			enumLitDurationItemProvider = new EnumLitDurationItemProvider(this);
		}

		return enumLitDurationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Datatype} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected DatatypeItemProvider	datatypeItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Datatype}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createDatatypeAdapter()
	{
		if (datatypeItemProvider == null)
		{
			datatypeItemProvider = new DatatypeItemProvider(this);
		}

		return datatypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Size} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected SizeItemProvider	sizeItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Size}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createSizeAdapter()
	{
		if (sizeItemProvider == null)
		{
			sizeItemProvider = new SizeItemProvider(this);
		}

		return sizeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Array} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ArrayItemProvider	arrayItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Array}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createArrayAdapter()
	{
		if (arrayItemProvider == null)
		{
			arrayItemProvider = new ArrayItemProvider(this);
		}

		return arrayItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Vector} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected VectorItemProvider	vectorItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Vector}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createVectorAdapter()
	{
		if (vectorItemProvider == null)
		{
			vectorItemProvider = new VectorItemProvider(this);
		}

		return vectorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Processor} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ProcessorItemProvider	processorItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Processor}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createProcessorAdapter()
	{
		if (processorItemProvider == null)
		{
			processorItemProvider = new ProcessorItemProvider(this);
		}

		return processorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.SynDEx} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected SynDExItemProvider	synDExItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.SynDEx}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createSynDExAdapter()
	{
		if (synDExItemProvider == null)
		{
			synDExItemProvider = new SynDExItemProvider(this);
		}

		return synDExItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ElementaryStructure} instances.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ElementaryStructureItemProvider	elementaryStructureItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ElementaryStructure}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createElementaryStructureAdapter()
	{
		if (elementaryStructureItemProvider == null)
		{
			elementaryStructureItemProvider = new ElementaryStructureItemProvider(this);
		}

		return elementaryStructureItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.CompoundStructure} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected CompoundStructureItemProvider	compoundStructureItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.CompoundStructure}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createCompoundStructureAdapter()
	{
		if (compoundStructureItemProvider == null)
		{
			compoundStructureItemProvider = new CompoundStructureItemProvider(this);
		}

		return compoundStructureItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.INOUT} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected INOUTItemProvider	inoutItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.INOUT}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createINOUTAdapter()
	{
		if (inoutItemProvider == null)
		{
			inoutItemProvider = new INOUTItemProvider(this);
		}

		return inoutItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.InternalDataConnection} instances.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected InternalDataConnectionItemProvider	internalDataConnectionItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.InternalDataConnection}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createInternalDataConnectionAdapter()
	{
		if (internalDataConnectionItemProvider == null)
		{
			internalDataConnectionItemProvider = new InternalDataConnectionItemProvider(this);
		}

		return internalDataConnectionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ParameterDeclaration} instances.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ParameterDeclarationItemProvider	parameterDeclarationItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ParameterDeclaration}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createParameterDeclarationAdapter()
	{
		if (parameterDeclarationItemProvider == null)
		{
			parameterDeclarationItemProvider = new ParameterDeclarationItemProvider(this);
		}

		return parameterDeclarationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ParameterValue} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ParameterValueItemProvider	parameterValueItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ParameterValue}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createParameterValueAdapter()
	{
		if (parameterValueItemProvider == null)
		{
			parameterValueItemProvider = new ParameterValueItemProvider(this);
		}

		return parameterValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.ConditionedStructure} instances.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ConditionedStructureItemProvider	conditionedStructureItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.ConditionedStructure}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createConditionedStructureAdapter()
	{
		if (conditionedStructureItemProvider == null)
		{
			conditionedStructureItemProvider = new ConditionedStructureItemProvider(this);
		}

		return conditionedStructureItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.Condition} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ConditionItemProvider	conditionItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.Condition}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createConditionAdapter()
	{
		if (conditionItemProvider == null)
		{
			conditionItemProvider = new ConditionItemProvider(this);
		}

		return conditionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.RepetitionConnection} instances.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected RepetitionConnectionItemProvider	repetitionConnectionItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.RepetitionConnection}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createRepetitionConnectionAdapter()
	{
		if (repetitionConnectionItemProvider == null)
		{
			repetitionConnectionItemProvider = new RepetitionConnectionItemProvider(this);
		}

		return repetitionConnectionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.INOUTInstance} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected INOUTInstanceItemProvider	inoutInstanceItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.INOUTInstance}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createINOUTInstanceAdapter()
	{
		if (inoutInstanceItemProvider == null)
		{
			inoutInstanceItemProvider = new INOUTInstanceItemProvider(this);
		}

		return inoutInstanceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.InCondInstance} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected InCondInstanceItemProvider	inCondInstanceItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.InCondInstance}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createInCondInstanceAdapter()
	{
		if (inCondInstanceItemProvider == null)
		{
			inCondInstanceItemProvider = new InCondInstanceItemProvider(this);
		}

		return inCondInstanceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fr.inria.aoste.syndex.InternalDependency} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected InternalDependencyItemProvider	internalDependencyItemProvider;

	/**
	 * This creates an adapter for a {@link fr.inria.aoste.syndex.InternalDependency}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createInternalDependencyAdapter()
	{
		if (internalDependencyItemProvider == null)
		{
			internalDependencyItemProvider = new InternalDependencyItemProvider(this);
		}

		return internalDependencyItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory()
	{
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
	{
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type)
	{
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type)
	{
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type)
	{
		if (isFactoryForType(type))
		{
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class<?>) type).isInstance(adapter)))
			{
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener)
	{
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener)
	{
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification)
	{
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null)
		{
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void dispose()
	{
		if (actuatorItemProvider != null)
			actuatorItemProvider.dispose();
		if (sensorItemProvider != null)
			sensorItemProvider.dispose();
		if (applicationItemProvider != null)
			applicationItemProvider.dispose();
		if (inputItemProvider != null)
			inputItemProvider.dispose();
		if (outputItemProvider != null)
			outputItemProvider.dispose();
		if (functionItemProvider != null)
			functionItemProvider.dispose();
		if (constantItemProvider != null)
			constantItemProvider.dispose();
		if (delayItemProvider != null)
			delayItemProvider.dispose();
		if (dataConnectionItemProvider != null)
			dataConnectionItemProvider.dispose();
		if (componentInstanceItemProvider != null)
			componentInstanceItemProvider.dispose();
		if (inInstanceItemProvider != null)
			inInstanceItemProvider.dispose();
		if (outInstanceItemProvider != null)
			outInstanceItemProvider.dispose();
		if (internalDependencyINItemProvider != null)
			internalDependencyINItemProvider.dispose();
		if (internalDependencyOUTItemProvider != null)
			internalDependencyOUTItemProvider.dispose();
		if (connecteableElementItemProvider != null)
			connecteableElementItemProvider.dispose();
		if (inCondPortItemProvider != null)
			inCondPortItemProvider.dispose();
		if (hardwareItemProvider != null)
			hardwareItemProvider.dispose();
		if (mediaItemProvider != null)
			mediaItemProvider.dispose();
		if (fpgaItemProvider != null)
			fpgaItemProvider.dispose();
		if (asicItemProvider != null)
			asicItemProvider.dispose();
		if (dspItemProvider != null)
			dspItemProvider.dispose();
		if (ramItemProvider != null)
			ramItemProvider.dispose();
		if (samItemProvider != null)
			samItemProvider.dispose();
		if (samptpItemProvider != null)
			samptpItemProvider.dispose();
		if (connectionHWItemProvider != null)
			connectionHWItemProvider.dispose();
		if (associationSWtoHWItemProvider != null)
			associationSWtoHWItemProvider.dispose();
		if (associationComtoProcItemProvider != null)
			associationComtoProcItemProvider.dispose();
		if (durationItemProvider != null)
			durationItemProvider.dispose();
		if (enumLitDurationItemProvider != null)
			enumLitDurationItemProvider.dispose();
		if (datatypeItemProvider != null)
			datatypeItemProvider.dispose();
		if (sizeItemProvider != null)
			sizeItemProvider.dispose();
		if (arrayItemProvider != null)
			arrayItemProvider.dispose();
		if (vectorItemProvider != null)
			vectorItemProvider.dispose();
		if (processorItemProvider != null)
			processorItemProvider.dispose();
		if (synDExItemProvider != null)
			synDExItemProvider.dispose();
		if (elementaryStructureItemProvider != null)
			elementaryStructureItemProvider.dispose();
		if (compoundStructureItemProvider != null)
			compoundStructureItemProvider.dispose();
		if (inoutItemProvider != null)
			inoutItemProvider.dispose();
		if (internalDataConnectionItemProvider != null)
			internalDataConnectionItemProvider.dispose();
		if (parameterDeclarationItemProvider != null)
			parameterDeclarationItemProvider.dispose();
		if (parameterValueItemProvider != null)
			parameterValueItemProvider.dispose();
		if (conditionedStructureItemProvider != null)
			conditionedStructureItemProvider.dispose();
		if (conditionItemProvider != null)
			conditionItemProvider.dispose();
		if (repetitionConnectionItemProvider != null)
			repetitionConnectionItemProvider.dispose();
		if (inoutInstanceItemProvider != null)
			inoutInstanceItemProvider.dispose();
		if (inCondInstanceItemProvider != null)
			inCondInstanceItemProvider.dispose();
		if (internalDependencyItemProvider != null)
			internalDependencyItemProvider.dispose();
	}

}
